]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Erstmal ein Commit:
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0a3" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 ipfiremake fcpci SMP=1
337 # ipfiremake promise-sata-300-tx SMP=1
338 ipfiremake zaptel SMP=1
339 ipfiremake fuse SMP=1
340 #ipfiremake linux XEN=1
341 ipfiremake linux
342 ipfiremake ipp2p
343 ipfiremake fcdsl
344 ipfiremake fcdsl2
345 ipfiremake fcdslsl
346 ipfiremake fcdslusb
347 ipfiremake fcdslslusb
348 ipfiremake fcpci
349 # ipfiremake promise-sata-300-tx
350 ipfiremake zaptel
351 ipfiremake fuse
352 ipfiremake pkg-config
353 ipfiremake cpio
354 ipfiremake klibc
355 ipfiremake mkinitcpio
356 ipfiremake udev KLIBC=1
357 ipfiremake expat
358 ipfiremake gdbm
359 ipfiremake gmp
360 ipfiremake pam
361 ipfiremake openssl
362 ipfiremake python
363 ipfiremake libnet
364 ipfiremake libjpeg
365 ipfiremake libpng
366 ipfiremake libtiff
367 ipfiremake libart
368 ipfiremake freetype
369 ipfiremake gd
370 ipfiremake popt
371 ipfiremake pcre
372 ipfiremake slang
373 ipfiremake newt
374 ipfiremake libcap
375 ipfiremake pciutils
376 ipfiremake libxml2
377 ipfiremake libxslt
378 ipfiremake BerkeleyDB
379 ipfiremake mysql
380 ipfiremake cyrus-sasl
381 ipfiremake openldap
382 ipfiremake apache2
383 ipfiremake php
384 ipfiremake apache2 PASS=C
385 ipfiremake arping
386 ipfiremake beep
387 ipfiremake bind
388 ipfiremake capi4k-utils
389 ipfiremake cdrtools
390 ipfiremake dnsmasq
391 ipfiremake dosfstools
392 ipfiremake reiserfsprogs
393 ipfiremake squashfstools
394 ipfiremake sysfsutils
395 ipfiremake ntfs-3g
396 ipfiremake ethtool
397 ipfiremake ez-ipupdate
398 ipfiremake fcron
399 ipfiremake GD
400 ipfiremake GD-Graph
401 ipfiremake GD-TextUtil
402 ipfiremake gnupg
403 ipfiremake hdparm
404 ipfiremake ibod
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipp2p IPT=1
410 ipfiremake moblock
411 ipfiremake linux-igd
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isdn4k-utils
418 ipfiremake mISDN
419 ipfiremake hwdata
420 ipfiremake kudzu
421 ipfiremake logrotate
422 ipfiremake logwatch
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nasm
427 ipfiremake URI
428 ipfiremake HTML-Tagset
429 ipfiremake HTML-Parser
430 ipfiremake Compress-Zlib
431 ipfiremake Digest
432 ipfiremake Digest-SHA1
433 ipfiremake Digest-HMAC
434 ipfiremake libwww-perl
435 ipfiremake Net-DNS
436 ipfiremake Net-IPv4Addr
437 ipfiremake Net_SSLeay
438 ipfiremake IO-Stringy
439 ipfiremake Unix-Syslog
440 ipfiremake Mail-Tools
441 ipfiremake MIME-Tools
442 ipfiremake Net-Server
443 ipfiremake Convert-TNEF
444 ipfiremake Convert-UUlib
445 ipfiremake Archive-Tar
446 ipfiremake Archive-Zip
447 ipfiremake Text-Tabs+Wrap
448 ipfiremake Locale-Country
449 ipfiremake XML-Parser
450 ipfiremake glib
451 ipfiremake GeoIP
452 ipfiremake fwhits
453 ipfiremake noip_updater
454 ipfiremake ntp
455 ipfiremake openssh
456 ipfiremake openswan
457 ipfiremake pptpclient
458 ipfiremake rrdtool
459 ipfiremake setserial
460 ipfiremake setup
461 ipfiremake snort
462 ipfiremake snortsnarf
463 ipfiremake oinkmaster
464 ipfiremake squid
465 ipfiremake squid-graph
466 ipfiremake squidguard
467 ipfiremake calamaris
468 ipfiremake tcpdump
469 ipfiremake traceroute
470 ipfiremake vlan
471 ipfiremake wireless
472 ipfiremake libsafe
473 ipfiremake 3c5x9setup
474 ipfiremake pakfire
475 ipfiremake java
476 ipfiremake spandsp
477 ipfiremake lzo
478 ipfiremake openvpn
479 ipfiremake pammysql
480 ipfiremake ghostscript
481 ipfiremake cups
482 ipfiremake samba
483 ipfiremake sudo
484 ipfiremake mc
485 ipfiremake wget
486 ipfiremake bridge-utils
487 ipfiremake screen
488 ipfiremake hddtemp
489 ipfiremake smartmontools
490 ipfiremake htop
491 ipfiremake postfix
492 ipfiremake fetchmail
493 ipfiremake cyrusimap
494 ipfiremake webcyradm
495 ipfiremake mailx
496 ipfiremake clamav
497 ipfiremake spamassassin
498 ipfiremake amavisd
499 ipfiremake stund
500 ipfiremake libpri
501 # ipfiremake bristuff
502 ipfiremake asterisk
503 ipfiremake mpg123
504 ipfiremake libmad
505 ipfiremake libogg
506 ipfiremake libvorbis
507 ipfiremake lame
508 ipfiremake sox
509 ipfiremake gnump3d
510 ipfiremake applejuice
511 ipfiremake ocaml
512 ipfiremake mldonkey
513 ipfiremake rsync
514 ipfiremake tcpwrapper
515 ipfiremake portmap
516 ipfiremake nfs
517 ipfiremake nmap
518 ipfiremake mbmon
519 ipfiremake iftop
520 ipfiremake ncftp
521 ipfiremake cftp
522 ipfiremake etherwake
523 ipfiremake ethereal
524 ipfiremake tftp-hpa
525 ipfiremake bwm-ng
526 ipfiremake tripwire
527 ipfiremake sysstat
528 ipfiremake vsftpd
529 }
530
531 buildinstaller() {
532 # Run installer scripts one by one
533 LOGFILE="$BASEDIR/log/_build.installer.log"
534 export LOGFILE
535 ipfiremake syslinux
536 ipfiremake as86
537 ipfiremake mbr
538 ipfiremake memtest
539 installmake linux-libc-header
540 installmake binutils
541 ipfiremake uClibc PASS=1
542 ipfiremake gcc INST=1
543 installmake uClibc PASS=2
544 installmake gcc INST=2
545 installmake uClibc PASS=3
546 installmake busybox
547 installmake udev
548 installmake slang
549 installmake newt
550 installmake gettext
551 installmake kbd
552 installmake popt
553 installmake sysvinit
554 installmake misc-progs
555 installmake e2fsprogs
556 installmake libaal
557 installmake reiser4progs
558 installmake reiserfsprogs
559 installmake sysfsutils
560 installmake util-linux
561 installmake pciutils
562 installmake zlib
563 installmake mtd
564 installmake wget
565 installmake hwdata
566 installmake kudzu
567 installmake installer
568 installmake initrd
569 }
570
571 buildpackages() {
572 LOGFILE="$BASEDIR/log/_build.packages.log"
573 export LOGFILE
574 echo "... see detailed log in _build.*.log files" >> $LOGFILE
575
576 installmake strip
577
578 # Generating list of packages used
579 echo -n "Generating packages list from logs" | tee -a $LOGFILE
580 rm -f $BASEDIR/doc/packages-list
581 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
582 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
583 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
584 fi
585 done
586 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
587 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
588 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
589 rm -f $BASEDIR/doc/packages-list
590 # packages-list.txt is ready to be displayed for wiki page
591 beautify message DONE
592
593 # Create images for install
594 if [ "$DEVEL" == "1" ]; then
595 ipfiremake cdrom ED=devel
596 fi
597 ipfiremake cdrom ED=full
598
599 # Check if there is a loop device for building in virtual environments
600 if [ -e /dev/loop0 ]; then
601 ipfiremake usb-stick
602 fi
603 ipfiremake pxe
604 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
605
606 ipfirepackages
607
608 # Cleanup
609 stdumount
610 rm -rf $BASEDIR/build/tmp/*
611
612 # Generating total list of files
613 echo -n "Generating files list from logs" | tee -a $LOGFILE
614 rm -f $BASEDIR/log/FILES
615 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
616 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
617 echo "##" >>$BASEDIR/log/FILES
618 echo "## `basename $i`" >>$BASEDIR/log/FILES
619 echo "##" >>$BASEDIR/log/FILES
620 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
621 fi
622 done
623 beautify message DONE
624
625 cd $PWD
626 }
627
628 ipfirepackages() {
629 # ipfiredist amavisd
630 # ipfiredist applejuice
631 # ipfiredist asterisk
632 ipfiredist clamav
633 ipfiredist cups
634 ipfiredist cyrus-sasl
635 # ipfiredist fetchmail
636 # ipfiredist gnump3d
637 # ipfiredist java
638 # ipfiredist mailx
639 # ipfiredist mldonkey
640 ipfiredist mpg123
641 # ipfiredist nfs
642 ipfiredist openldap
643 # ipfiredist postfix
644 ipfiredist samba
645 # ipfiredist sox
646 # ipfiredist spamassassin
647 ipfiredist tripwire
648 ipfiredist vsftpd
649 # ipfiredist webcyradm
650 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
651 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
652 rm -rf $BASEDIR/build/install/packages/*
653 }
654
655 # See what we're supposed to do
656 case "$1" in
657 build)
658 clear
659 BUILDMACHINE=`uname -m`
660 DEVEL=0
661 if [ "$2" == "--devel" ]; then
662 DEVEL=1
663 fi
664 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
665 #only restore on a clean disk
666 if [ ! -f log/cleanup-toolchain-2-tools ]; then
667 if [ ! -n "$PACKAGE" ]; then
668 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
669 prepareenv
670 buildtoolchain
671 else
672 PACKAGENAME=${PACKAGE%.tar.gz}
673 beautify build_stage "Packaged toolchain compilation"
674 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
675 tar zxf $PACKAGE
676 prepareenv
677 else
678 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
679 fi
680 fi
681 else
682 echo -n "Using installed toolchain" | tee -a $LOGFILE
683 beautify message SKIP
684 prepareenv
685 fi
686
687 beautify build_start
688 beautify build_stage "Building LFS"
689 buildbase
690
691 beautify build_stage "Building IPFire"
692 buildipfire
693
694 # Setzen des IPFire Builds
695 if [ "$FIREBUILD" ]; then
696 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
697 else
698 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
699 fi
700
701 beautify build_stage "Building installer"
702 buildinstaller
703
704 beautify build_stage "Building packages"
705 buildpackages
706 beautify build_end
707 ;;
708 shell)
709 # enter a shell inside LFS chroot
710 # may be used to changed kernel settings
711 prepareenv
712 entershell
713 ;;
714 changelog)
715 echo -n "Loading new Changelog from SVN: "
716 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
717 beautify message DONE
718 ;;
719 clean)
720 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
721 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
722 $LOSETUP -d $i 2>/dev/null
723 done
724 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
725 umount $i
726 done
727 stdumount
728 for i in `seq 0 7`; do
729 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
730 umount /dev/loop${i} 2>/dev/null;
731 losetup -d /dev/loop${i} 2>/dev/null;
732 fi;
733 done
734 rm -rf $BASEDIR/build
735 rm -rf $BASEDIR/cdrom
736 rm -rf $BASEDIR/packages
737 rm -rf $BASEDIR/log
738 if [ -h /tools ]; then
739 rm -f /tools
740 fi
741 beautify message DONE
742 ;;
743 downloadsrc)
744 if [ ! -d $BASEDIR/cache ]; then
745 mkdir $BASEDIR/cache
746 fi
747 mkdir -p $BASEDIR/log
748 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
749 FINISHED=0
750 cd $BASEDIR/lfs
751 for c in `seq $MAX_RETRIES`; do
752 if (( FINISHED==1 )); then
753 break
754 fi
755 FINISHED=1
756 cd $BASEDIR/lfs
757 for i in *; do
758 if [ -f "$i" -a "$i" != "Config" ]; then
759 echo -ne "Loading $i"
760 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
761 if [ $? -ne 0 ]; then
762 beautify message FAIL
763 FINISHED=0
764 else
765 if [ $c -eq 1 ]; then
766 beautify message DONE
767 fi
768 fi
769 fi
770 done
771 done
772 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
773 ERROR=0
774 for i in *; do
775 if [ -f "$i" -a "$i" != "Config" ]; then
776 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
777 if [ $? -ne 0 ]; then
778 echo -ne "MD5 difference in lfs/$i"
779 beautify message FAIL
780 ERROR=1
781 fi
782 fi
783 done
784 if [ $ERROR -eq 0 ]; then
785 echo -ne "${BOLD}all files md5sum match${NORMAL}"
786 beautify message DONE
787 else
788 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
789 beautify message FAIL
790 fi
791 cd - >/dev/null 2>&1
792 ;;
793 toolchain)
794 clear
795 prepareenv
796 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
797 buildtoolchain
798 BUILDMACHINE=`uname -m`
799 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
800 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
801 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
802 build/{bin,etc,usr/bin,usr/local} \
803 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
804 log >> $LOGFILE
805 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
806 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
807 stdumount
808 ;;
809 gettoolchain)
810 BUILDMACHINE=`uname -m`
811 # arbitrary name to be updated in case of new toolchain package upload
812 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
813 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
814 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
815 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
816 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
817 cd $BASEDIR/cache/toolchains
818 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
819 if [ $? -ne 0 ]; then
820 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
821 else
822 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
823 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
824 else
825 exiterror "$PACKAGE.md5 did not match, check downloaded package"
826 fi
827 fi
828 else
829 echo "Toolchain is already downloaded. Exiting..."
830 fi
831 ;;
832 othersrc)
833 prepareenv
834 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
835 chroot $LFS /tools/bin/env -i HOME=/root \
836 TERM=$TERM PS1='\u:\w\$ ' \
837 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
838 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
839 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
840 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
841 if [ $? -eq "0" ]; then
842 beautify message DONE
843 else
844 beautify message FAIL
845 fi
846 stdumount
847 ;;
848 svn)
849 case "$2" in
850 update|up)
851 # clear
852 echo -ne "Loading the latest source files...\n"
853 if [ $3 ]; then
854 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
855 else
856 svn update | tee -a $PWD/log/_build.svn.update.log
857 fi
858 if [ $? -eq "0" ]; then
859 beautify message DONE
860 else
861 beautify message FAIL
862 exit 1
863 fi
864 echo -ne "Writing the svn-info to a file"
865 svn info > $PWD/svn_status
866 if [ $? -eq "0" ]; then
867 beautify message DONE
868 else
869 beautify message FAIL
870 exit 1
871 fi
872 chmod 755 $0
873 exit 0
874 ;;
875 commit|ci)
876 clear
877 if [ -f /usr/bin/mcedit ]; then
878 export EDITOR=/usr/bin/mcedit
879 fi
880 if [ -f /usr/bin/nano ]; then
881 export EDITOR=/usr/bin/nano
882 fi
883 echo -ne "Selecting editor $EDITOR..."
884 beautify message DONE
885 if [ -e /sbin/yast ]; then
886 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
887 $0 changelog
888 fi
889 fi
890 update_langs
891 svn commit
892 $0 svn up
893 if [ -n "$FTP_CACHE_URL" ]; then
894 $0 uploadsrc
895 fi
896 ;;
897 dist)
898 if [ $3 ]; then
899 SVN_REVISION=$3
900 fi
901 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
902 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
903 exit 0
904 fi
905 echo -en "REV $SVN_REVISION: Downloading..."
906 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
907 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
908 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
909 evaluate 1
910
911 echo -en "REV $SVN_REVISION: Compressing files..."
912 if [ -e ipfire-source/trunk/make.sh ]; then
913 chmod 755 ipfire-source/trunk/make.sh
914 fi
915 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
916 evaluate 1
917 echo -en "REV $SVN_REVISION: Cleaning up..."
918 rm ipfire-source/ -r
919 evaluate 1
920 ;;
921 diff|di)
922 update_langs
923 echo -ne "Make a local diff to last svn revision"
924 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
925 evaluate 1
926 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
927 svn status
928 ;;
929 esac
930 ;;
931 uploadsrc)
932 PWD=`pwd`
933 cd $BASEDIR/cache/
934 echo -e "Uploading cache to ftp server:"
935 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
936 for i in *; do
937 if [ "$i" == "toolchains" ]; then continue; fi
938 grep -q $i /tmp/ftplist
939 if [ "$?" -ne "0" ]; then
940 echo -ne "$i"
941 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
942 if [ "$?" -ne "0" ]; then
943 beautify message FAIL
944 fi
945 fi
946 done
947 rm -f /tmp/ftplist
948 cd $PWD
949 exit 0
950 ;;
951 upload)
952 case "$2" in
953 iso)
954 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
955 cat <<EOF > .ftp-commands
956 mkdir -p $FTP_ISO_PATH$SVN_REVISION
957 ls -lah
958 quit
959 EOF
960 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
961 rm -f .ftp-commands
962 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
963 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
964 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
965 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
966 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
967 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
968 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
969 fi
970 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
971 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
972 if [ "$?" -eq "0" ]; then
973 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
974 else
975 echo -e "There was an error while uploading the iso to the ftp server."
976 exit 1
977 fi
978 if [ "$3" = "--with-sources-cd" ]; then
979 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
980 fi
981 ;;
982 paks)
983 cat <<EOF > .ftp-commands
984 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
985 ls -lah
986 quit
987 EOF
988 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
989 rm -f .ftp-commands
990 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
991 if [ "$?" -eq "0" ]; then
992 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
993 else
994 echo -e "There was an error while uploading the packages to the ftp server."
995 exit 1
996 fi
997 ;;
998 esac
999 ;;
1000 batch)
1001 if [ "$2" = "--background" ]; then
1002 batch_script
1003 exit $?
1004 fi
1005 if [ `screen -ls | grep -q ipfire` ]; then
1006 echo "Build is already running, sorry!"
1007 exit 1
1008 else
1009 if [ "$2" = "--rebuild" ]; then
1010 export IPFIRE_REBUILD=1
1011 echo "REBUILD!"
1012 else
1013 export IPFIRE_REBUILD=0
1014 fi
1015 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1016 screen -dmS ipfire $0 batch --background
1017 evaluate 1
1018 exit 0
1019 fi
1020 ;;
1021 watch)
1022 watch_screen
1023 ;;
1024 pxe)
1025 case "$2" in
1026 start)
1027 start_tftpd
1028 ;;
1029 stop)
1030 stop_tftpd
1031 ;;
1032 reload|restart)
1033 reload_tftpd
1034 ;;
1035 esac
1036 exit 0
1037 ;;
1038 lang)
1039 update_langs
1040 ;;
1041 packages)
1042 case "$2" in
1043 sign)
1044 sign_packages
1045 ;;
1046 esac
1047 ;;
1048 "")
1049 clear
1050 svn info
1051 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1052 do
1053 case $name in
1054 "IPFIRE: Downloadsrc")
1055 $0 downloadsrc
1056 ;;
1057 "IPFIRE: Build (silent)")
1058 $0 build-silent
1059 ;;
1060 "IPFIRE: Watch Build")
1061 $0 watch
1062 ;;
1063 "IPFIRE: Batch")
1064 $0 batch
1065 ;;
1066 "IPFIRE: Clean")
1067 $0 clean
1068 ;;
1069 "SVN: Update")
1070 $0 svn update
1071 ;;
1072 "Help")
1073 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1074 cat doc/make.sh-usage
1075 ;;
1076 "LOG: Tail")
1077 tail -f log/_*
1078 ;;
1079 "Exit")
1080 break
1081 ;;
1082 esac
1083 done
1084 ;;
1085 config)
1086 make_config
1087 ;;
1088 *)
1089 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1090 cat doc/make.sh-usage
1091 ;;
1092 esac